Subject: [Int-area] MPLS Extension Headers RE: [mpls] draft-zzhang-intarea-generic-delivery-functions

From: Haoyu Song <[email-masked]>
Date: Mon, 8 Mar 2021 16:55:25 +0000

Below is the set of drafts centered on the MPLS extension header proposal we have published two years ago, which we would like to ask the WG to consider if supporting multiple services is a desired scenario. As I said, this pertains to MPLS only, but the similar mechanism has been realized in IPv6 EH, so we have two most important types of networks covered already. As for the other types of networks, the encapsulation method needs to be individually figured out, but the EH format itself can be reused of course.

  *   draft-andersson-mpls-eh-label-stack-operations<https://datatracker.ietf.org/doc/draft-andersson-mpls-eh-label-stack-operations/>
  *   draft-song-mpls-eh-indicator<https://datatracker.ietf.org/doc/draft-song-mpls-eh-indicator/>
  *   draft-andersson-mpls-eh-architecture<https://datatracker.ietf.org/doc/draft-andersson-mpls-eh-architecture/>
  *   draft-song-mpls-extension-header<https://datatracker.ietf.org/doc/draft-song-mpls-extension-header/>
Thanks,
Haoyu
From: Haoyu Song
Sent: Sunday, March 7, 2021 6:22 PM
To: Jeffrey (Zhaohui) Zhang <[email-masked]>; 'mpls' <[email-masked]>; [email-masked]; [email-masked]; Ron Bonica <[email-masked]>; Kireeti Kompella <[email-masked]>; [email-masked]
Subject: RE: [mpls] draft-zzhang-intarea-generic-delivery-functions

Hi Jeffrey,
Yes. Understood. I'm just suggesting a generic method in MPLS to support a stack of functions.
Thanks!
Haoyu

From: Jeffrey (Zhaohui) Zhang <[email-masked]<mailto:[email-masked]>>
Sent: Sunday, March 7, 2021 4:21 PM
To: Haoyu Song <[email-masked]<mailto:[email-masked]>>; 'mpls' <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Ron Bonica <[email-masked]<mailto:[email-masked]>>; Kireeti Kompella <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
Subject: RE: [mpls] draft-zzhang-intarea-generic-delivery-functions

Hi Haoyu,

I read your draft and my understanding is that it is specifically for MPLS. The intention of GDFH is to apply it for generic functions that can be applied at different layers, including MPLS but not limited to it.

Jeffrey

From: Haoyu Song <[email-masked]<mailto:[email-masked]>>
Sent: Thursday, February 25, 2021 9:08 PM
To: 'mpls' <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Ron Bonica <[email-masked]<mailto:[email-masked]>>; Kireeti Kompella <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Jeffrey (Zhaohui) Zhang <[email-masked]<mailto:[email-masked]>>
Subject: RE: [mpls] draft-zzhang-intarea-generic-delivery-functions

[External Email. Be cautious of content]

Hi all,

Just adding a discussion point, we have proposed the concept of extension header to MPLS, so that it can provide a generic way to handle multiple service extension headers.
https://www.ietf.org/archive/id/draft-song-mpls-extension-header-02.txt<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2Fwww.ietf.org%2Farchive%2Fid%2Fdraft-song-mpls-extension-header-02.txt__%3B!!NEt6yMaO-gk!XarlEYHAbFlJQ0IRmF_jseHaPVVdTOnzPB20jotk9UIwAWUdahfu5gbP6zjXYQJd%24&data=04%7C01%7Chaoyu.song%40futurewei.com%7C0a702cb32e524003f48308d8e1c80eca%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637507596652810239%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=tmKB%2B6Pz9e5lpe42EE6NvB7715uwLxzIw56Fqhgh9jQ%3D&reserved=0>

Cheers,
Haoyu

From: Int-area <[email-masked]<mailto:[email-masked]>> On Behalf Of Kireeti Kompella
Sent: Thursday, February 25, 2021 3:19 PM
To: [email-masked]<mailto:[email-masked]>; 'John E Drake' <jdrake=[email-masked]<mailto:jdrake=[email-masked]>>; 'Stewart Bryant' <[email-masked]<mailto:[email-masked]>>
Cc: 'mpls' <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Ron Bonica <[email-masked]<mailto:[email-masked]>>; Kireeti Kompella <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; 'Jeffrey (Zhaohui) Zhang' <zzhang=[email-masked]<mailto:zzhang=[email-masked]>>
Subject: Re: [Int-area] [mpls] draft-zzhang-intarea-generic-delivery-functions

Hi Adrian,

I'm all for multiple label stacks (if meaningful).  I had put that in an early version of the FAI bSPL, with a "real end stack" bit for those woke forwarding engines that needed to know.

The hard lesson I take away from those FEs that look at the nibble following the EoS is to make sure it isn't 0x4 or 0x6, not so much that a single label stack is the only viable solution.  So, keep this option alive ....

Cheers,
Kireeti.
From: Adrian Farrel <[email-masked]<mailto:[email-masked]>>
Date: Thursday, February 25, 2021 at 13:53
To: 'John E Drake' <jdrake=[email-masked]<mailto:jdrake=[email-masked]>>, 'Stewart Bryant' <[email-masked]<mailto:[email-masked]>>
Cc: 'mpls' <[email-masked]<mailto:[email-masked]>>, [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>, Kireeti Kompella <[email-masked]<mailto:[email-masked]>>, Ron Bonica <[email-masked]<mailto:[email-masked]>>, [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>, [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>, 'Jeffrey (Zhaohui) Zhang' <zzhang=[email-masked]<mailto:zzhang=[email-masked]>>
Subject: RE: [mpls] draft-zzhang-intarea-generic-delivery-functions
> Multiple labels, each with the BoS set, was suggested during the MPLS-TP days
> (Niel Harrison, in particular, was a big proponent) but was shot down because it
> would apparently break existing hardware implementations.

Yeah, I was a big fan of that. I even thought it was architecturally the right thing to do for carrying one MPLS service over an MPLS transport. It would have solved many of the MPLS-TP requirements.

But as John says, lots of hardware then (and probably now) sees bottom of stack and starts to sniff the next nibble. Thus, contiguous label stacks and control words were the only viable solution. It took George Swallow a while to beat this into my head.

Cheers,
Adrian

Juniper Business Use Only

Juniper Business Use Only